/*
 * Part of the GaBIEn project.
 * (Graphics and Basic Input Engine)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */
package gabien.music;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import gabien.ISoundDriver;

public class PiyoPiyoWaveTrack {
    //These should be stored as bytes, but Java bytes are signed, and I don't want to get near that insanity...
    public int[] waveForm=new int[256];
    public int[] envelope=new int[64];
    public int volume,length,octave,icon;
    public PiyoPiyoWaveTrack()
    {
    }
    public void read(InputStream is) throws IOException {
        octave=PiyoPiyoFile.read8(is);
        icon=PiyoPiyoFile.read8(is);
        PiyoPiyoFile.read8(is);
        PiyoPiyoFile.read8(is);
        length=PiyoPiyoFile.read32(is);
        volume=PiyoPiyoFile.read32(is);
        PiyoPiyoFile.read32(is);
        PiyoPiyoFile.read32(is);
        PiyoPiyoFile.readArray(is, waveForm);
        PiyoPiyoFile.readArray(is, envelope);
    }
    public void write(OutputStream os) throws IOException {
        os.write(octave);
        os.write(icon);
        os.write(0);
        os.write(0);
        PiyoPiyoFile.write32(os, length);
        PiyoPiyoFile.write32(os, volume);
        PiyoPiyoFile.write32(os, 0);
        PiyoPiyoFile.write32(os, 0);
        PiyoPiyoFile.writeArray(os, waveForm);
        PiyoPiyoFile.writeArray(os, envelope);
    }
}
