/*
 * Part of the GaBIEn project.
 * (Graphics and Basic Input Engine)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */
package gabien.ui;

import gabien.IGrInDriver;
/**
 * @author matt
 */
public abstract class UIElement {
    protected Rect elementBounds=new Rect(0,0,1,1);
    public void setBounds(Rect r) {
        elementBounds=new Rect(r.x,r.y,r.width,r.height);
    }
    public Rect getBounds() {
        Rect r=new Rect(elementBounds.x,elementBounds.y,elementBounds.width,elementBounds.height);
        return r;
    }
    public abstract void updateAndRender(int ox,int oy,double deltaTime,boolean selected,IGrInDriver igd);
    //
    public abstract void handleClick(int x,int y,int button);
    public void handleDrag(int x,int y) {}
}
