/*
 * Part of the JavaChan project.
 * (Java ikaChan)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */

package javachan;

import gabien.IGrInDriver;
import java.util.Random;
import gabien.IGrInDriver.IImage;
import gabien.ui.Rect;
import javachan.bosses.BasicBoss;
import javachan.bosses.IronheadBoss;

/**
 * As in,you could serialize this class and get a Ika.rec kind of gamestate.
 * This class is a result of a refactor involving renaming GameData and
 * splitting it up. Honestly,it was a mess.I hate long files,they are hard to
 * navigate :)
 * 
 * @author matt
 */
public class GameState implements IPhysicsObject {
    // Note that these values are the default for when the game starts-i.e. a
    // new GameState.
    // If you load a gamestate,or run physics,or whatever-these become null and
    // void.

    // I am assuming 0=No item.
    // If that changed,tell me!
    public double inGameTime = 0;
    public int[] items = new int[10];
    public boolean[] flags = new boolean[10000];
    public boolean bossMode = false;// During a boss,DO NOT SAVE.
    public int bossID = 0;
    public double lastAnnoyTime = 0;
    public int capacitorCharge = 0;
    public int capacitorMode = -2;
    public int capacitorTicks = 0;
    public double playerX = 40, playerY = 104;
    public int entityCount = 0;// If >=12,Ironhead doesn't exist anymore.
    public double playerVX = 0, playerVY = 0;
    public int playerXP = 0;
    public int playerLevel = 0;
    public int playerEnergy = 4;
    public boolean playerDead = false;
    public int playerNoDamageTicks = 0;
    public int movementTimer = 0;// In ticks.
    public boolean greatEscape = false;
    public GameStateMap map = new GameStateMap();
    public GameStateNPChar npcs = new GameStateNPChar();
    public GameStateParticles particles = new GameStateParticles();
    public BasicBoss[] bosses = new BasicBoss[] { new IronheadBoss(0) };
    public int[] levelXPTable = { 8, 28, 52, 74, 102, 360, 852 };
    public int[] levelEnergyTable = { 4, 8, 12, 18, 26, 34, 62 };
    // NOTE:Move this to MainGame?
    private boolean swimDebounce = false;

    // ------------------------NO VARIABLES PAST THIS POINT. I MEAN IT. --matt
    // UTILITY
    public int getMaxXP() {
        return levelXPTable[playerLevel];
    }

    public int getMaxEnergy() {
        return levelEnergyTable[playerLevel];
    }

    public void initGreatEscape() {
        playerVX = -0.2;
        playerVY = 0.1;
        greatEscape = true;
    }

    public void greatEscapeTick() {
        playerY = playerY + playerVY;
        playerX = playerX + playerVX;

        playerVY -= 0.0025;
        playerVX *= 0.95;
    }

    public void mainTick(int inputLR, boolean swimKey, boolean swimKeyD, PhysicsEngine physics, IEventCallback ev, double inGameTime) {
        boolean canSwim = true;
        boolean releaseIsCapacitorThrust = false;
        if (playerNoDamageTicks > 0)
            playerNoDamageTicks--;
        if (capacitorTicks > 0) {
            capacitorTicks--;
            if (capacitorMode == 0) {
                playerVX = 0;
                playerVY = -1 / 5.0;
            } else {
                playerVY = 0;
                playerVX = capacitorMode / 5.0;
            }
            if (capacitorTicks == 0) {
                capacitorTicks = 0;
                capacitorMode = -2;
            }
            boolean[] gaf = physics.doUpdate(ev, this, this, inGameTime);
            if (gaf[0] || gaf[1] || gaf[2] || gaf[3]) {
                capacitorTicks = 0;
                capacitorMode = -2;
            }
            return;
        }
        if (capacitorMode != -2) {
            if (capacitorCharge <= 0) {
                canSwim = false;
                releaseIsCapacitorThrust = true;
            } else {
                capacitorCharge--;
            }
        }
        if (hasItem(8)) {
            // ha ha,try to mess with me now,X window system! (X window system
            // promptly pounds me into ground)
            if (swimKeyD) {
                if (capacitorMode == inputLR) {
                    // Well,any swimming that can happen likely has.
                    canSwim = false;
                } else {
                    capacitorCharge = 20;
                }
                capacitorMode = inputLR;
            } else {
                if (releaseIsCapacitorThrust) {
                    capacitorTicks = 40;
                } else {
                    // we released prematurely,so deactivate capacitor
                    capacitorCharge = 0;
                    capacitorMode = -2;
                }
            }
        } else {
            // Key debouncer.Capacitor will debounce keys for us,but if there's
            // no capacitor...
            if (swimDebounce) {
                canSwim = false;
            }
            swimDebounce = swimKeyD;
        }
        if (movementTimer > 0) {
            movementTimer--;
        } else {
            if (swimKey && canSwim) {
                movementTimer = 4;
                double bspd = 0.04;
                switch (inputLR) {
                case 0:
                    playerVY -= translatePixelMysteryUnits(724);
                    particles.addParticle("Bubble:0", playerX + 0.5, playerY + 0.9, 0, bspd);
                    break;
                case -1:
                    playerVX -= translatePixelMysteryUnits(512);
                    playerVY -= translatePixelMysteryUnits(512);
                    particles.addParticle("Bubble:0", playerX + 0.9, playerY + 0.9, bspd, bspd);
                    break;
                case 1:
                    playerVX += translatePixelMysteryUnits(512);
                    playerVY -= translatePixelMysteryUnits(512);
                    particles.addParticle("Bubble:0", playerX + 0.1, playerY + 0.9, -bspd, bspd);
                    break;
                }
            }
        }
        // Perform Ikachan's GravFric stuff.
        double friction = translatePixelMysteryUnits(8);
        if (playerVX <= -friction)
            playerVX += friction;
        if (playerVX >= friction)
            playerVX -= friction;

        playerVY += translatePixelMysteryUnits(0x14);

        double maxVel = translatePixelMysteryUnits(0x800);
        if (playerVX > maxVel)
            playerVX = maxVel;
        if (playerVX < -maxVel)
            playerVX = -maxVel;
        if (playerVY > maxVel)
            playerVY = maxVel;
        if (playerVY < -maxVel)
            playerVY = -maxVel;

        playerX += playerVX;
        playerY += playerVY;
        physics.doUpdate(ev, this, this, inGameTime);
    }

    // Added so that Pixel Mystery Units can be used to import values.
    // Also gives a good idea of when Pixel Mystery Units are being used.
    public static double translatePixelMysteryUnits(int i) {
        double d = i;
        return d / (1 << 13);
    }

    public void bossesTick() {
        for (BasicBoss b : bosses) {
            if (b.isAlive(this)) {
                b.onUpdate(this);
            }
        }
    }

    public void mainNPCTick(PhysicsEngine physics, double inGameTime) {
        for (int x = 0; x < npcs.npcTable.length; x++) {
            if (npcs.npcTable[x].exists) {
                npcs.npcTypes[npcs.npcTable[x].entityType].doTick(npcs.npcTable[x], this, inGameTime);
                boolean[] bb = physics.doUpdate(null, npcs.npcTable[x], this, inGameTime);
                npcs.npcTable[x].onGround = bb[2];
            }
        }
    }

    public boolean hasItem(int i) {
        for (int p = 0; p < items.length; p++) {
            if (items[p] == i)
                return true;
        }
        return false;
    }

    public int charType() {
        boolean spikehat = hasItem(1);
        boolean ship = hasItem(11);
        if (ship)
            return 2;
        if (spikehat)
            return 0;
        return 1;
    }

    public void restoreCharacterPosition() {
        playerNoDamageTicks = 0;
        playerX = 40;
        playerY = 104;
        playerVX = 0;
        playerVY = 0;
        playerDead = false;
        playerEnergy = getMaxEnergy();
        // CharType is not affected.
        movementTimer = 0;
    }

    // RENDERING.Call in this order:RenderBack,Map.Render(pass
    // 0),NPChar.Render,RenderPC,Map.Render(pass 1)

    public void renderBack(int px, int py, double Time, IGrInDriver gd) {
        IImage back = gd.getImage("Pbm/Back.pbm", 0, 0, 0);
        for (int xx = -(back.getWidth() * 2); xx <= gd.getWidth() + back.getWidth(); xx += back.getWidth()) {
            boolean movement = false;
            for (int yy = -(back.getHeight() * 2); yy <= gd.getHeight() + (back.getHeight() * 2); yy += back.getHeight()) {
                movement = !movement;
                gd.blitImage(0, 0, back.getWidth(), back.getHeight(), (movement ? (back.getWidth() / 2) : 0) + (xx + ((px / 4) % back.getWidth())), yy + ((py / 4) % back.getWidth()), back);
            }
        }
    }

    // LR can be -1,0,or 1.
    public void renderPC(int px, int py, int LR, IGrInDriver gd, double InGameTime) {
        IImage Ikachan = null;
        for (BasicBoss b : bosses) {
            if (b.isAlive(this)) {
                b.doRender(px, py, this, gd);
            }
        }
        int CharTy = charType();
        if (CharTy == 0) {
            Ikachan = gd.getImage("Pbm/MyChar.pbm", 0, 0, 0);
        }
        if (CharTy == 1) {
            Ikachan = gd.getImage("Pbm/MyChar2.pbm", 0, 0, 0);
        }
        if (CharTy == 2) {
            Ikachan = gd.getImage("Pbm/MyChar3.pbm", 0, 0, 0);
        }
        int stateX = 0;
        int stateY = 2;
        if (LR == -1) {
            stateY = 0;
        }
        if (LR == 1) {
            stateY = 1;
        }
        if (movementTimer > 0) {
            stateX = 1;
        }
        if (capacitorMode != -2) {
            if (capacitorMode == 0)
                stateY = 2;
            if (capacitorMode == -1)
                stateY = 0;
            if (capacitorMode == 1)
                stateY = 1;
            // if charge complete...
            if (capacitorCharge <= 0) {
                stateX = 2;
            }
            // if we're actually using the capacitor,override charge...
            if (capacitorTicks > 0) {
                stateX = 3;
            }
        }
        if (playerNoDamageTicks > 0) {
            if ((playerNoDamageTicks % 2) == 0)
                return;
        }
        if (playerDead)
            return;
        int ofsX=((Ikachan.getWidth()/4)-16)/2;
        int ofsY=((Ikachan.getHeight()/3)-16)/2;
        gd.blitBCKImage(stateX * (Ikachan.getWidth() / 4), stateY * (Ikachan.getHeight() / 3), Ikachan.getWidth() / 4, Ikachan.getHeight() / 3, ((int) (playerX * 16) + px) - ofsX, ((int) (playerY * 16) + py) - ofsY, Ikachan);
    }

    // --------------------------------------------------------------IPhysicsObject
    // Implementation(Player Object)

    @Override
    public double getX() {
        return playerX;
    }

    @Override
    public double getY() {
        return playerY;
    }

    @Override
    public double getVX() {
        return playerVX;
    }

    @Override
    public double getVY() {
        return playerVY;
    }

    // This is what I saved this method for.
    @Override
    public Rect getRectangle() {
        return new Rect((int) (playerX * 16) + 2, (int) (playerY * 16) + 1, 12, 14);
    }

    @Override
    public void setX(double X) {
        playerX = X;
    }

    @Override
    public void setY(double Y) {
        playerY = Y;
    }

    @Override
    public void setVX(double VX) {
        playerVX = VX;
    }

    @Override
    public void setVY(double VY) {
        playerVY = VY;
    }

    public void applyXPEnergy(int xpAmount, int energyAmount) {
        if (xpAmount > 0) {
            particles.addParticle("Damage:" + xpAmount, playerX, playerY, 0, -0.025);
        }
        playerXP += xpAmount;
        int maxxp = getMaxXP();
        while (playerXP >= maxxp) {
            particles.addParticle("LevelUp:0", playerX, playerY, 0, -0.025);
            playerXP -= maxxp;
            if (playerLevel != levelXPTable.length - 1) {
                playerLevel++;
            }
            maxxp = getMaxXP();
        }
        if (energyAmount < 0) {
            if (playerNoDamageTicks > 0) {
                return;
            }
            particles.addParticle("Damage:" + energyAmount, playerX, playerY, 0, -0.025);
            playerNoDamageTicks = 80;
        }
        playerEnergy += energyAmount;
        if (playerEnergy > getMaxEnergy())
            playerEnergy = getMaxEnergy();
        if (playerEnergy <= 0) {
            playerEnergy = 0;
            playerDead = true;
            Random r = new Random();
            for (int px = 0; px < 16; px++) {
                particles.addParticle("Star:0", playerX, playerY, (r.nextDouble() - 0.5) / 16.0, (r.nextDouble() - 0.5) / 16.0);
            }
        }
    }
}
