/*
 * Part of the JavaChan project.
 * (Java ikaChan)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */

package javachan;

import gabien.IGrInDriver;
import java.util.LinkedList;

/**
 * Bubble,Star,LevelUp,Damage.
 * 
 * @author matt
 */
public class GameStateParticles {
    public static final String[] particleStates = {
            "Damage:UN", "Pbm/Damage.pbm", "0.8;0.8;8;8", "40;F", null,
            "Damage:-9", "Pbm/Damage.pbm", "1.8;0.8;8;8", "40;F", null,
            "Damage:-8", "Pbm/Damage.pbm", "2.8;0.8;8;8", "40;F", null,
            "Damage:-7", "Pbm/Damage.pbm", "3.8;0.8;8;8", "40;F", null,
            "Damage:-6", "Pbm/Damage.pbm", "4.8;0.8;8;8", "40;F", null,
            "Damage:-5", "Pbm/Damage.pbm", "5.8;0.8;8;8", "40;F", null,
            "Damage:-4", "Pbm/Damage.pbm", "6.8;0.8;8;8", "40;F", null,
            "Damage:-3", "Pbm/Damage.pbm", "7.8;0.8;8;8", "40;F", null,
            "Damage:-2", "Pbm/Damage.pbm", "8.8;0.8;8;8", "40;F", null,
            "Damage:-1", "Pbm/Damage.pbm", "9.8;0.8;8;8", "40;F", null,
            "Damage:0",  "Pbm/Damage.pbm", "0.8;1.8;8;8", "40;F", null,
            "Damage:1",  "Pbm/Damage.pbm", "1.8;1.8;8;8", "40;F", null,
            "Damage:2",  "Pbm/Damage.pbm", "2.8;1.8;8;8", "40;F", null,
            "Damage:3",  "Pbm/Damage.pbm", "3.8;1.8;8;8", "40;F", null,
            "Damage:4",  "Pbm/Damage.pbm", "4.8;1.8;8;8", "40;F", null,
            "Damage:5",  "Pbm/Damage.pbm", "5.8;1.8;8;8", "40;F", null,
            "Damage:6",  "Pbm/Damage.pbm", "6.8;1.8;8;8", "40;F", null,
            "Damage:7",  "Pbm/Damage.pbm", "7.8;1.8;8;8", "40;F", null,
            "Damage:8",  "Pbm/Damage.pbm", "8.8;1.8;8;8", "40;F", null, 
            "Damage:9",  "Pbm/Damage.pbm", "9.8;1.8;8;8", "40;F", null,
            
            "Bubble:0",  "Pbm/Bubble.pbm", "0.8;0.8;8;8", "20;B", "Bubble:1",
            "Bubble:1",  "Pbm/Bubble.pbm", "1.8;0.8;8;8", "20;B", "Bubble:2",
            "Bubble:2",  "Pbm/Bubble.pbm", "2.8;0.8;8;8", "20;B", "Bubble:3",
            "Bubble:3",  "Pbm/Bubble.pbm", "3.8;0.8;8;8", "20;B", "Bubble:4",
            "Bubble:4",  "Pbm/Bubble.pbm", "4.8;0.8;8;8", "20;B", "Bubble:5",
            "Bubble:5",  "Pbm/Bubble.pbm", "5.8;0.8;8;8", "20;B", null,
            
            "Star:0",    "Pbm/Star.pbm", "0.8;0.8;8;8", "20;F", "Star:1",
            "Star:1",    "Pbm/Star.pbm", "1.8;0.8;8;8", "20;F", "Star:2",
            "Star:2",    "Pbm/Star.pbm", "2.8;0.8;8;8", "20;F", "Star:3",
            "Star:3",    "Pbm/Star.pbm", "3.8;0.8;8;8", "20;F", "Star:4",
            "Star:4",    "Pbm/Star.pbm", "4.8;0.8;8;8", "20;F", "Star:5",
            "Star:5",    "Pbm/Star.pbm", "5.8;0.8;8;8", "20;F", null,
            
            "LevelUp:0", "Pbm/LevelUp.pbm", "0.0;0.16;64;16", "20;F", "LevelUp:1",
            "LevelUp:1", "Pbm/LevelUp.pbm", "0.0;1.16;64;16", "20;F", "LevelUp:2",
            "LevelUp:2", "Pbm/LevelUp.pbm", "0.0;0.16;64;16", "20;F", "LevelUp:3",
            "LevelUp:3", "Pbm/LevelUp.pbm", "0.0;1.16;64;16", "20;F", null,
            };

    public static class Particle {
        public double posX, posY, velX, velY;
        public int life, PX, PY, W, H;
        public char type;
        public String image;
        public String nextState;

        // Image and NextState you can set yourself.
        public void load(String ImageData, String LifeType) {
            String[] id = ImageData.split(";");
            String[] lt = LifeType.split(";");
            type = lt[1].charAt(0);
            PX = Integer.parseInt(id[0].split("\\.")[0])
                    * Integer.parseInt(id[0].split("\\.")[1]);
            PY = Integer.parseInt(id[1].split("\\.")[0])
                    * Integer.parseInt(id[1].split("\\.")[1]);
            W = Integer.parseInt(id[2]);
            H = Integer.parseInt(id[3]);
            life = Integer.parseInt(lt[0]);
        }

        public void setState(String StateName) {
            for (int p = 0; p < particleStates.length; p += 5) {
                if (particleStates[p].equals(StateName)) {
                    image = particleStates[p + 1];
                    nextState = particleStates[p + 4];
                    load(particleStates[p + 2], particleStates[p + 3]);
                    return;
                }
            }
            System.out.println("Particles:No such state:" + StateName);
            life = 0;
            image = "Pbm/MyChar.pbm";
        }

        public void tick() {
            posX += velX;
            posY += velY;
            life--;
            if (life == 0) {
                if (nextState != null) {
                    setState(nextState);
                }
            }
            if (type == 'B')
                velY -= 0.005;
        }
    }

    LinkedList<Particle> particles = new LinkedList<Particle>();

    public void addParticle(String State, double X, double Y, double VX,
            double VY) {
        Particle p = new Particle();
        p.setState(State);
        p.posX = X;
        p.posY = Y;
        p.velX = VX;
        p.velY = VY;
        particles.add(p);
    }

    public void render(int ox, int oy, IGrInDriver igd) {
        for (Particle p : particles) {
            igd.blitBCKImage(p.PX, p.PY, p.W, p.H, (ox + (int) (p.posX * 16))
                    - (p.W / 2), (oy + (int) (p.posY * 16)) - (p.H / 2),
                    igd.getImage(p.image, 0, 0, 0));
        }
    }

    public void doUpdate() {
        for (Particle p : ((LinkedList<Particle>) particles.clone())) {
            p.tick();

            if (p.life == 0) {
                particles.remove(p);
            }
        }
    }
}
