/*
 * Part of the JavaChan project.
 * (Java ikaChan)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */
package javachan;

import gabien.GaBIEn;

import java.io.FileInputStream;
import java.util.logging.Level;
import java.util.logging.Logger;

import gabien.music.PiyoPiyoPlayer;

/**
 *
 * @author matt
 */
public class MusicDriver_InternalPlayer implements IMusicDriver {
    public PiyoPiyoPlayer musicPlayer;
    public String music = "";

    @Override
    public void playMusic() {
        stopMusic();
        try {
            FileInputStream fis = new FileInputStream(music);
            musicPlayer = new PiyoPiyoPlayer(fis,GaBIEn.getSound());
            fis.close();
            System.out.println("music start \"" + music + "\"");
        } catch (Exception ex) {
            Logger.getLogger(MusicDriver_InternalPlayer.class.getName()).log(
                    Level.SEVERE, null, ex);
        }
    }

    @Override
    public boolean stopMusic() {
        System.out.println("COMM. music stop attempt");
        if (musicPlayer != null) {
            System.out.println("music stop");
            musicPlayer.stopAll();
            musicPlayer = null;
            return true;
        }
        System.out.println("COMM. already stopped");
        return false;
    }

    @Override
    public boolean isPlaying() {
        return musicPlayer!=null;
    }

    @Override
    public void setMusic(String filename) {
        music = filename;
        if (stopMusic()) {
            playMusic();
        }
    }

    @Override
    public void doUpdate(double deltaTime) {
        if (musicPlayer!=null)
        {
            musicPlayer.updateBeats(deltaTime);
            musicPlayer.updateEnvelopes(deltaTime);
        }
    }

    @Override
    public double nextUpdate() {
        if (musicPlayer==null)
            return 0.1;
        double beatTime=musicPlayer.piyoFile.beatTime();
        return beatTime-musicPlayer.withinBeatPosition;
    }

}
