/*
 * Part of the JavaChan project.
 * (Java ikaChan)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */
package javachan.blocks;

import javachan.GameState;
import gabien.IGrInDriver;
import gabien.IGrInDriver.IImage;
import javachan.IPhysicsObject;

/**
 *
 * @author matt
 */
public class DirectionBlockType extends BasicBlockType {
    @Override
    public int getAmountOfSubTypes(IGrInDriver igd) {
        return 4;
    }

    @Override
    protected String getBlockImage() {
        return "Pbm/PrtDir.pbm";
    }

    @Override
    public void handleSoftCollision(int x, int y, GameState gs,
            IPhysicsObject ipo) {
        if (ipo.getX() > x)
            if (ipo.getY() > y)
                if (ipo.getX() < x + 1)
                    if (ipo.getY() < y + 1) {
                        double dx = 0;
                        double dy = 0;
                        double spd = GameState.translatePixelMysteryUnits(0x32);
                        int sub = gs.map.data[x + (y * gs.map.width)] % 16;
                        if (sub == 0)
                            dx = -spd;
                        if (sub == 1)
                            dx = spd;
                        if (sub == 2)
                            dy = -spd;
                        if (sub == 3)
                            dy = spd;
                        ipo.setVX(ipo.getVX() + dx);
                        ipo.setVY(ipo.getVY() + dy);
                    }
    }

    @Override
    public boolean collisionStops() {
        return false;
    }

    @Override
    public void doRender(int pass, int ox, int oy, int sub, IGrInDriver gd,
            double Time) {
        if (pass != 0)
            return;
        IImage img = gd.getImage(getBlockImage(), 0, 0, 0);

        if (sub == 0)
            gd.blitBCKImage((int) ((Time - Math.floor(Time)) * 64) % 16, 0, 16,
                    16, ox, oy, img);
        if (sub == 1)
            gd.blitBCKImage(
                    ((int) (1.0 - (Time - Math.floor(Time)) * 64) % 16) + 16,
                    0, 16, 16, ox, oy, img);
        if (sub == 2)
            gd.blitBCKImage(0, (int) ((Time - Math.floor(Time)) * 64) % 16, 16,
                    16, ox, oy, img);
        if (sub == 3)
            gd.blitBCKImage(0,
                    ((int) (1.0 - (Time - Math.floor(Time)) * 64) % 16) + 16,
                    16, 16, ox, oy, img);

    }
}
