/*
 * Part of the JavaChan project.
 * (Java ikaChan)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */
package javachan.bosses;

import javachan.GameState;
import javachan.IEventCallback;
import gabien.IGrInDriver;
import gabien.ui.Rect;

/**
 *
 * @author matt
 */
public abstract class BasicBoss {
    public double posX,posY;
    public int ID;
    public BasicBoss(int ID)
    {
        this.ID=ID;
    }
    protected boolean isBattling(GameState gs)
    {
        if (gs.bossMode)
        {
            if (gs.bossID==ID)
            {
                return true;
            }
        }
        return false;
    }
    public abstract void onHit(GameState gs,int Direction,IEventCallback iec,double Time);
    public abstract boolean isAlive(GameState gs);
    public abstract Rect getRectangle();
    public abstract void onUpdate(GameState gs);
    //ox and oy are map-topleft render controls.(as per usual)
    public abstract void doRender(int ox,int oy,GameState gs,IGrInDriver igd);

    public abstract void initBattle();
}
