/*
 * Part of the JavaChan project.
 * (Java ikaChan)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */
package javachan.bosses;

import java.util.Random;
import javachan.GameState;
import javachan.IEventCallback;
import gabien.IGrInDriver;
import gabien.IGrInDriver.IImage;
import gabien.ui.Rect;

/**
 *
 * @author matt
 */
public class IronheadBoss extends BasicBoss {

    public int ironheadHealth = 15;
    public double VX, VY;
    public boolean Charging = false;

    public IronheadBoss(int ID) {
        super(ID);
        posX = 130;
        posY = 90;
    }

    @Override
    public void onHit(GameState gs, int hitironhead, IEventCallback iec, double Time) {
        if (!isBattling(gs)) {
            if (gs.lastAnnoyTime < (Time - 2)) {
                gs.lastAnnoyTime = Time;
                iec.startEvent(1000);
            }
        } else {
            if (!Charging) {
                if (hitironhead == 3) {
                    if (gs.capacitorTicks > 0) {
                        ironheadHealth -= 3;
                    } else {
                        ironheadHealth--;
                    }
                    VY = gs.playerVY - 0.1;
                    posY -= 4.0f / 16.0f;
                    if (ironheadHealth <= 0) {
                        gs.bossMode = false;
                        iec.startEvent(1001);
                    }
                } else {
                    gs.applyXPEnergy(0, -3);
                }
            } else {
                gs.applyXPEnergy(0, -3);
            }
        }
    }

    @Override
    public Rect getRectangle() {
        return new Rect((int) (posX * 16), (int) (posY * 16), 64, 24);
    }

    @Override
    public void doRender(int px, int py, GameState gs, IGrInDriver gd) {
        IImage Ironhead = gd.getImage("Pbm/Ironhead.pbm", 0, 0, 0);
        int charge = (Ironhead.getHeight() / 4) * 3;
        if (!Charging) {
            charge = 0;
        }
        if (VX <= 0) {
            gd.blitBCKImage(0, charge, Ironhead.getWidth() / 4, Ironhead.getHeight() / 4, ((int) (posX * 16) + px), ((int) (posY * 16) + py), Ironhead);
            gd.blitBCKImage((Ironhead.getWidth() / 4), 0, Ironhead.getWidth() / 4, Ironhead.getHeight() / 4, ((int) (posX * 16) + px) + (Ironhead.getWidth() / 4), ((int) (posY * 16) + py), Ironhead);
        } else {
            gd.blitBCKImage((Ironhead.getWidth() / 2), charge, Ironhead.getWidth() / 4, Ironhead.getHeight() / 4, ((int) (posX * 16) + px) + (Ironhead.getWidth() / 4), ((int) (posY * 16) + py), Ironhead);
            gd.blitBCKImage((Ironhead.getWidth() / 2) + (Ironhead.getWidth() / 4), 0, Ironhead.getWidth() / 4, Ironhead.getHeight() / 4, ((int) (posX * 16) + px), ((int) (posY * 16) + py), Ironhead);
        }
    }

    @Override
    public boolean isAlive(GameState gs) {
        if (gs.entityCount < 12) {
            return true;
        }
        return false;
    }

    @Override
    public void onUpdate(GameState gs) {
        Random r = new Random();

        double IronheadTgtX = 128 + r.nextInt(4);
        double IronheadTgtY = 88 + r.nextInt(4);
        if (isBattling(gs)) {
            IronheadTgtX = gs.playerX;
            IronheadTgtY = gs.playerY;
        }
        IronheadTgtX -= 2;
        //IRONHEAD
        if (Charging) {
            VY = 0;
            if (Math.abs(VX) < 0.05) {
                Charging = false;
            }
            VX *= 0.99;
        } else {
            VX *= 0.98;
            VY *= 0.98;
            if (posX > IronheadTgtX) {
                VX -= 0.001;
            }
            if (posX < IronheadTgtX) {
                VX += 0.001;
            }
            if (posY > IronheadTgtY) {
                VY -= 0.001;
            }
            if (posY < IronheadTgtY) {
                VY += 0.001;
            }
            if (isBattling(gs)) {
                if (new Rect(0, (int) (posY * 16) + 6, 1, 12).intersects(new Rect(0, (int) (gs.playerY * 16) - 4, 1, 8))) {
                    if (posX > IronheadTgtX) {
                        VX = -0.2;
                    }
                    if (posX < IronheadTgtX) {
                        VX = 0.2;
                    }
                    VY = 0;
                    Charging = true;
                }
            }
        }

        posX += VX;
        posY += VY;

    }

    @Override
    public void initBattle() {
        ironheadHealth=15;
    }
}
