/*
 * Part of the JavaChan project.
 * (Java ikaChan)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */
package javachan.games.editorui;

import gabien.IGrInDriver;
import gabien.IGrInDriver.IImage;
import gabien.ui.Rect;
import gabien.ui.UIPanel;

/**
 *
 * @author matt
 */
public class UIHorizontalList extends UIPanel {

    public static interface ListEntry {
        public boolean isEqualTo(ListEntry le);
        public void doRender(int centerx,int centery,double DeltaTime,IGrInDriver igd);
    }
    public int selectedItem=0;
    public Runnable onChange;
    public UIHorizontalList()
    {
        super();
        allElements.add(theScrollbar);
    }
    public UIScrollbar theScrollbar=new UIScrollbar();
    public int scrollbarScale=4;
    public ListEntry[] availableTypes=null;

    @Override
    public void updateAndRender(int ox, int oy, double DeltaTime, boolean selected, IGrInDriver igd) {
        //UINPCTYPES LAYOUT CODE
        int roomneeded=availableTypes.length;
        roomneeded-=(elementBounds.width/32);
        if (roomneeded<0) roomneeded=0;
        theScrollbar.setBounds(new Rect(0,elementBounds.height-16,(roomneeded*scrollbarScale)+16,16));
        //--END UINPCTYPES LAYOUT CODE
            IImage edit=igd.getImage("TileEditor.png", 0, 0, 0);
        for (int px=0;px<elementBounds.width;px+=32)
        {
            int remaining=elementBounds.width-px;
            if (remaining>32) remaining=32;
            igd.blitImage(224, 0, remaining, 16, ox+px, oy+0, edit);
            igd.blitImage(224, 0, remaining, 16, ox+px, oy+16, edit);
            igd.blitImage(224, 0, remaining, 32, ox+px, oy+32, edit);
        }
        for (int p=0;p<elementBounds.width/32;p++)
        {
            int i=p+(theScrollbar.value/scrollbarScale);
            if (i>=availableTypes.length) break;
            if (i<0) continue;
            if (i==selectedItem)
            {
            igd.blitImage(256, 0, 32, 16, (32*p)+ox, 0, edit);
            igd.blitImage(256, 0, 32, 16, (32*p)+ox, 16, edit);
            igd.blitImage(256, 0, 32, 32, (32*p)+ox, 32, edit);
            }
            availableTypes[i].doRender(ox+16+(32*p), oy+24, DeltaTime, igd);
        }
        super.updateAndRender(ox, oy, DeltaTime, selected, igd);
    }
    @Override
    public void handleClick(int x, int y,int button) {
        if (y<elementBounds.height-16)
        {
            int i=(x/32)+(theScrollbar.value/scrollbarScale);
            if (i<0)
                return;
            if (i>=availableTypes.length)
                return;
            selectedItem=i;
            onChange.run();
            return;
        }
        super.handleClick(x,y,button);
    }

}
