package javachan.games.minorstates;

/*
 * Part of the JavaChan project.
 * (Java ikaChan)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */
import gabien.IGrInDriver.IImage;
import javachan.Game;
import javachan.games.Keymap;
import javachan.games.MainGame;

/**
 * Note: This is tied up in MainGame, it would take me a while to fully get this
 * out. It's tied to the TSC code, basically.
 * 
 * @author Matt
 *
 */
public class ChatMinorState implements MinorState {
    public int subState;
    public double generalMinorUseTimer, animationTimer;

    public ChatMinorState() {
    }

    @Override
    public void doUpdate(MainGame mainGame, Game g, double deltaTime,
            boolean tickNow) {
        animationTimer += deltaTime;
        double chatSpeed = 15;
        if (subState == 1) {
            generalMinorUseTimer += deltaTime * chatSpeed;
            if (g.graphics.isKeyDown(Keymap.VK_SWIM)) {
                generalMinorUseTimer += deltaTime * chatSpeed;
            }
            mainGame.currentChatReveal = (int) generalMinorUseTimer;
            String currentChatUsable = mainGame.currentChat;
            if (currentChatUsable.contains("\r\n")) {
                currentChatUsable = mainGame.currentChat.split("\r\n")[0];
                if (mainGame.currentChat.split("\r\n").length >= 2)
                    currentChatUsable += "\r\n"
                            + mainGame.currentChat.split("\r\n")[1];
            }
            if (generalMinorUseTimer > currentChatUsable.length()) {
                IImage tinyguy = g.graphics.getImage("Pbm/Cursor.pbm", 0, 0, 0);// cute
                                                                                // star
                                                                                // thing.
                int frame = ((int) (animationTimer * 10)) % 6;
                g.graphics.blitBCKImage(48 + ((frame > 3) ? ((frame - 2) * 8)
                        : (frame * 8)), (frame > 3) ? 0 : 16, 8, 16, 295,
                        g.graphics.getHeight() - 27, tinyguy);
                mainGame.currentChatReveal = currentChatUsable.length();
                if (g.graphics.isKeyDown(Keymap.VK_SWIM)) {
                    advanceChat(mainGame);
                }
                generalMinorUseTimer = mainGame.currentChatReveal;
            }
        }
        if (subState == 4) {
            String CurrentChatUsable = mainGame.currentChat;
            if (CurrentChatUsable.contains("\r\n")) {
                CurrentChatUsable = mainGame.currentChat.split("\r\n")[0];
                if (mainGame.currentChat.split("\r\n").length >= 2)
                    CurrentChatUsable += "\r\n"
                            + mainGame.currentChat.split("\r\n")[1];
            }
            generalMinorUseTimer += deltaTime * chatSpeed;
            if (g.graphics.isKeyDown(Keymap.VK_SWIM)) {
                generalMinorUseTimer += deltaTime * chatSpeed;
            }
            mainGame.currentChatReveal = (int) generalMinorUseTimer;
            if (mainGame.currentChatReveal > CurrentChatUsable.length()) {
                mainGame.currentChatReveal = CurrentChatUsable.length();
                advanceChat(mainGame);// This will either leave chat or set
                // CurrentChatReveal.
                generalMinorUseTimer = mainGame.currentChatReveal;
            }
        }
        if (subState == 5) {
            if (tickNow) {
                // And now you know how <wa updates Isogin instances.
                mainGame.gameState.mainNPCTick(mainGame.physicsEngine,
                        mainGame.gameState.inGameTime);
                mainGame.gameState.particles.doUpdate();
            }
            generalMinorUseTimer -= deltaTime;
            if (generalMinorUseTimer <= 0)
                mainGame.minorState = null;
        }

    }
    public void advanceChat(MainGame mainGame) {
        if (mainGame.currentChat.split("\r\n").length > 2) {
            mainGame.currentChat = mainGame.currentChat
                    .substring(mainGame.currentChat.indexOf("\r\n") + 2);
            mainGame.currentChatReveal = mainGame.currentChat.indexOf("\r\n");
        } else {
            mainGame.minorState = null;
        }
    }
}
