/*
 * Part of the JavaChan project.
 * (Java ikaChan)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */
package javachan.games.minorstates;

import gabien.IGrInDriver.IImage;
import javachan.Game;
import javachan.games.Keymap;
import javachan.games.MainGame;

public class ItemsMinorState implements MinorState {
    public int selectedItem;

    @Override
    public void doUpdate(MainGame mainGame, Game g, double DeltaTime, boolean tickNow) {
        if (g.graphics.isKeyJustPressed(Keymap.VK_ITEMS)) {
            mainGame.minorState = null;// leave itembox
        }
        if (g.graphics.isKeyJustPressed(Keymap.VK_LEFT)) {
            selectedItem--;
        }
        if (g.graphics.isKeyJustPressed(Keymap.VK_RIGHT)) {
            selectedItem++;
        }
        while (selectedItem < 0)
            selectedItem += mainGame.gameState.items.length;
        while (selectedItem >= mainGame.gameState.items.length)
            selectedItem -= mainGame.gameState.items.length;
        if (g.graphics.isKeyJustPressed(Keymap.VK_SWIM)) {
            int ti = mainGame.gameState.items[selectedItem];
            if (ti != 0) {
                mainGame.minorState = null;
                mainGame.startEvent(ti + 2000);
            }
        }
        IImage ItemBox = g.graphics.getImage("Pbm/ItemBox.pbm", 0, 0, 0);
        IImage Items = g.graphics.getImage("Pbm/Item.pbm", 0, 0, 0);
        IImage Cursor = g.graphics.getImage("Pbm/Cursor.pbm", 0, 0, 0);
        int ibx = (g.graphics.getWidth() / 2) - (ItemBox.getWidth() / 2);
        int iby = (g.graphics.getHeight() / 2) - (ItemBox.getHeight() / 2);
        g.graphics.blitImage(0, 0, ItemBox.getWidth(), ItemBox.getHeight(), ibx, iby, ItemBox);
        for (int i = 0; i < mainGame.gameState.items.length; i++) {
            int p = ((mainGame.gameState.items[i] - 1) * 16);
            if (mainGame.gameState.items[i] != 0) {
                g.graphics.blitImage(p, 0, 16, 16, ibx + 8 + (i * 16), iby + 8, Items);
            }
        }
        g.graphics.blitBCKImage(32, 0, 16, 16, ibx + 8 + (selectedItem * 16), iby + 8, Cursor);
    }

}
