/*
 * Part of the JavaChan project.
 * (Java ikaChan)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */
package javachan.npcs;

import javachan.GameState;
import javachan.GameStateNPChar;
import javachan.GameStateNPChar.NPCCharacter;
import gabien.IGrInDriver;
import gabien.IGrInDriver.IImage;
import gabien.ui.Rect;

/**
 *
 * @author matt
 */
public class AttackStarNPCType extends BasicNPCType {

    // RX14
    public boolean isChibi = false;

    public AttackStarNPCType(boolean chibi) {
        isChibi = chibi;
        drawSizeX = isChibi ? 8 : 16;
        drawSizeY = isChibi ? 8 : 16;
    }

    public Rect GetRectangle(GameStateNPChar.NPCCharacter In) {
        if (isChibi)
            return new Rect((int) (In.posX * 16), (int) (In.posY * 16), 8, 8);
        return new Rect((int) (In.posX * 16) + 1, (int) (In.posY * 16) + 1, 14, 14);
    }

    @Override
    public void doTick(NPCCharacter npc, GameState gs, double Time) {
        if (npc.posX > gs.playerX)
            npc.velX -= GameState.translatePixelMysteryUnits(0x18);
        if (npc.posX < gs.playerX)
            npc.velX += GameState.translatePixelMysteryUnits(0x18);
        if (npc.posY > gs.playerY)
            npc.velY -= GameState.translatePixelMysteryUnits(0x10);
        if (npc.posY < gs.playerY)
            npc.velY += GameState.translatePixelMysteryUnits(0x10);
        if (npc.posX > gs.playerX)
            npc.displayX = 0;
        if (npc.posX < gs.playerX)
            npc.displayX = 1; // NOTE: treated as a byte!
        double pmu8000 = GameState.translatePixelMysteryUnits(0x8000);
        if (gs.playerX < (npc.posX - pmu8000))
            if (gs.playerX > (npc.posX + pmu8000))
                if (gs.playerY < (npc.posY - pmu8000))
                    if (gs.playerY > (npc.posY + pmu8000))
                        npc.displayX = 2; // NOTE: treated as a byte!
        npc.touchWillHurt = (gs.playerY <= npc.posY + GameState.translatePixelMysteryUnits(0x2000)) ? 1 : 0;
        npc.entityStatus++; // NOTE: treated as a word!
        if (npc.entityStatus > 8) // NOTE: treated as a word!
        {
            npc.displayY++; // NOTE: treated as a byte!
            npc.entityStatus = 0; // NOTE: treated as a word!
            if (npc.displayY > 1) // NOTE: treated as a byte!
                npc.displayY = 0; // NOTE: treated as a byte!
        }
        double pmu400 = GameState.translatePixelMysteryUnits(0x400);
        if (npc.velX > pmu400)
            npc.velX = pmu400;
        if (npc.velX < -pmu400)
            npc.velX = -pmu400;
        if (npc.velY > pmu400)
            npc.velY = pmu400;
        if (npc.velY < -pmu400)
            npc.velY = -pmu400;
        npc.posX += npc.velX;
        npc.posY += npc.velY;
    }

    @Override
    protected int touchDamage(NPCCharacter npc) {
        return isChibi ? 0 : 2;
    }

    @Override
    protected int levelToHurt() {
        return 2;
    }

    @Override
    protected int rewardXP() {
        return 3;
    }
}
