/*
 * Part of the JavaChan project.
 * (Java ikaChan)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */
package javachan.npcs;

import javachan.GameState;
import javachan.GameStateNPChar;
import javachan.GameStateNPChar.NPCCharacter;
import javachan.IEventCallback;
import gabien.IGrInDriver;
import gabien.IGrInDriver.IImage;

/**
 *
 * @author matt
 */
public class CrabNPCType extends BasicNPCType {

    @Override
    public void doTick(NPCCharacter npc, GameState gs, double Time) {
        double pmu10000 = GameState.translatePixelMysteryUnits(0x10000);
        double pmu200 = GameState.translatePixelMysteryUnits(0x200);
        double pmu800 = GameState.translatePixelMysteryUnits(0x800);
        double pmu10 = GameState.translatePixelMysteryUnits(0x10);
        if (npc.touchWillHurt != 0) {
            if ((npc.touchWillHurt - 1) != 0)
                return;
            npc.entityStatus++;
            if (npc.entityStatus > 0x02) {
                npc.entityStatus = 0;
                npc.displayX++;
                if (npc.displayX > 3)
                    npc.displayX = 2;
            }
            if (npc.posX < (npc.ofsX - pmu10000))
                if (npc.velX > -pmu200)
                    npc.velX -= GameState.translatePixelMysteryUnits(0x10);
            if (npc.posX > (npc.ofsX + pmu10000))
                if (npc.velX < pmu200)
                    npc.velX += GameState.translatePixelMysteryUnits(0x10);

            if (npc.velY < pmu800)
                npc.velY += GameState.translatePixelMysteryUnits(0x14);

            npc.posX += npc.velX;
            npc.posY += npc.velY;

            if (npc.velY <= 0)
                return;

            npc.touchWillHurt = 0;
            npc.displayY = 0;
            return;
        }

        int dir=npc.displayX;
        if (npc.posX < (npc.ofsX - pmu10000))
            dir = 1;

        if (npc.posX > (npc.ofsX + pmu10000))
            dir = 0;

        if (dir == 0)
            if (npc.velX > -pmu200)
                npc.velX -= pmu10;

        if (dir == 1)
            if (npc.velX < pmu200)
                npc.velX += pmu10;

        if (!npc.onGround)
            npc.entityStatus2++;

        if (npc.entityStatus2 > 0x50) {
            npc.entityStatus2 = 0;
            if ((npc.collisionType != 2) || gs.hasItem(4)) {
                npc.velY = -GameState.translatePixelMysteryUnits(0x400);
            } else {
                npc.velY = -GameState.translatePixelMysteryUnits(0x600);
                npc.touchWillHurt = 1;
                npc.displayY = 1;
            }
        }

        npc.entityStatus++;

        if (npc.entityStatus > 0xA) {
            npc.entityStatus = 0;
            npc.displayX++;
            if (npc.displayX > 1)
                npc.displayX = 0;
        }

        if (npc.velY < pmu800)
            npc.velY += GameState.translatePixelMysteryUnits(0x14);

        npc.posX += npc.velX;
        npc.posY += npc.velY;

        if (npc.onGround)
            npc.displayY = 2;
    }

    @Override
    protected int touchDamage(NPCCharacter npc) {
        return 2;
    }

    @Override
    protected int levelToHurt() {
        return 2;
    }

    @Override
    protected int rewardXP() {
        return 3;
    }
}
