/*
 * Part of the JavaChan project.
 * (Java ikaChan)
 *
 *        DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *                    Version 2, December 2004 
 *
 * Modified by gamemanj <asdd2808@gmail.com> to remove expletives
 * Original copyright (C) 2004 Sam Hocevar <sam@hocevar.net> 
 *
 * Everyone is permitted to copy and distribute verbatim or modified 
 * copies of this license document, and changing it is allowed as long 
 * as the name is changed. 
 *
 *            DO WHATEVER YOU WANT TO PUBLIC LICENSE 
 *   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION 
 *
 *  0. You just DO WHATEVER YOU WANT TO.
 */
package javachan.npcs;

import javachan.GameState;
import javachan.GameStateNPChar;
import javachan.GameStateNPChar.NPCCharacter;
import gabien.IGrInDriver;
import gabien.IGrInDriver.IImage;

/**
 *
 * @author matt
 */
public class GlobefishNPCType extends BasicNPCType {

    @Override
    protected int touchDamage(NPCCharacter npc) {
        return 1;
    }

    @Override
    protected int levelToHurt() {
        return 1;
    }

    @Override
    protected int rewardXP() {
        return 1;
    }

    @Override
    public void doTick(NPCCharacter npc, GameState gs, double Time) {
        if (npc.touchWillHurt != 0) {
            if (npc.posX > gs.playerX)
                npc.displayY = 0;
            if (npc.posX < gs.playerX)
                npc.displayY = 1;
            npc.entityStatus2++;
            if (npc.entityStatus2 > 2) {
                npc.entityStatus2 = 0;
                npc.displayX++;
                if (npc.displayX > 3)
                    npc.displayX = 2;
            }
            npc.entityStatus--;
            if (npc.entityStatus > 0xC8)
                return;
            npc.touchWillHurt = 0;
            npc.displayX = 0;
            return;
        }
        double pmu6 = GameState.translatePixelMysteryUnits(6);
        if (npc.posX > npc.ofsX)
            npc.velX -= pmu6;
        if (npc.posX < npc.ofsX)
            npc.velX += pmu6;

        double pmu4 = GameState.translatePixelMysteryUnits(4);
        if (npc.posY > npc.ofsY)
            npc.velY -= pmu4;
        if (npc.posY < npc.ofsY)
            npc.velY += pmu4;

        if (npc.velX < 0)
            npc.displayY = 0;
        if (npc.velX > 0)
            npc.displayY = 1;

        npc.entityStatus2++;
        if (npc.entityStatus2 > 0x3C) {
            npc.entityStatus2 = 0;
            npc.displayX++;
            if (npc.displayX > 1)
                npc.displayX = 0;
        }

        double pmu800 = GameState.translatePixelMysteryUnits(0x800);
        if (npc.velX > pmu800)
            npc.velX = pmu800;
        if (npc.velX < -pmu800)
            npc.velX = -pmu800;
        if (npc.velY > pmu800)
            npc.velY = pmu800;
        if (npc.velY < -pmu800)
            npc.velY = -pmu800;

        npc.posX += npc.velX;
        npc.posY += npc.velY;

        if (npc.entityStatus > 0)
            npc.entityStatus--;
        if (npc.entityStatus != 0)
            return;
        if (gs.hasItem(4))
            return;

        double pmuA000 = GameState.translatePixelMysteryUnits(0xA000);
        if ((npc.posX - pmuA000) >= gs.playerX)
            return;
        if ((npc.posX + pmuA000) <= gs.playerX)
            return;
        if ((npc.posY - pmuA000) >= gs.playerY)
            return;
        if ((npc.posY + pmuA000) <= gs.playerY)
            return;
        if (npc.collisionType == 2)
            npc.touchWillHurt = 1;
        npc.entityStatus = 0x12C;
    }
}
